---
title: <input type="week">
slug: Web/HTML/Element/input/week
tags:
  - Element
  - Forms
  - HTML
  - HTML Input Types
  - HTML forms
  - HTML input
  - Input
  - Input Element
  - Input Type
  - Input Types
  - Reference
  - Week
  - Weeks
---
<div>{{HTMLRef("Input_types")}}</div>

<p><span class="seoSummary">{{HTMLElement("input")}} elements of type <strong><code>week</code></strong> create input fields allowing easy entry of a year plus the <a href="https://en.wikipedia.org/wiki/ISO_8601#Week_dates">ISO 8601 week number</a> during that year (i.e., week 1 to <a href="https://en.wikipedia.org/wiki/ISO_8601#Week_dates">52 or 53</a>).</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/input-week.html", "tabbed-shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The control's user interface varies from browser to browser; cross-browser support is currently a bit limited, with only Chrome/Opera and Microsoft Edge supporting it at this time. In non-supporting browsers, the control degrades gracefully to function identically to <code><a href="/en-US/docs/Web/HTML/Element/input/text">&lt;input type="text"&gt;</a></code>.</p>

<p>In Chrome/Opera the <code>week</code> control provides slots to fill in week and year values, a pop-up calendar interface to select them more visually, and an "X" button to clear the control's value.</p>

<p><img alt="" src="week-control-chrome.png" style="display: block; height: 235px; margin: 0px auto; width: 320px;"></p>

<p>The Edge <code>week</code> control is somewhat more elaborate, opening up week and year pickers with sliding reels.</p>

<p><img alt="" src="week-control-edge.png" style="display: block; height: 391px; margin: 0px auto; width: 227px;"></p>

<table class="properties">
 <tbody>
  <tr>
   <td><strong>{{anch("Value")}}</strong></td>
   <td>A {{domxref("DOMString")}} representing a week and year, or empty</td>
  </tr>
  <tr>
   <td><strong>Events</strong></td>
   <td>{{domxref("HTMLElement/change_event", "change")}} and {{domxref("HTMLElement/input_event", "input")}}</td>
  </tr>
  <tr>
   <td><strong>Supported common attributes</strong></td>
   <td>{{htmlattrxref("autocomplete", "input")}}, {{htmlattrxref("list", "input")}}, {{htmlattrxref("readonly", "input")}}, and {{htmlattrxref("step", "input")}}</td>
  </tr>
  <tr>
   <td><strong>IDL attributes</strong></td>
   <td><code>value</code>, <code>valueAsDate</code>, <code>valueAsNumber</code>, and <code>list</code>.</td>
  </tr>
  <tr>
   <td><strong>Methods</strong></td>
   <td>{{domxref("HTMLInputElement.select", "select()")}}, {{domxref("HTMLInputElement.stepDown", "stepDown()")}}, and {{domxref("HTMLInputElement.stepUp", "stepUp()")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Value">Value</h2>

<p>A {{domxref("DOMString")}} representing the value of the week/year entered into the input. The format of the date and time value used by this input type is described in {{SectionOnPage("/en-US/docs/Web/HTML/Date_and_time_formats", "Format of a valid week string")}}.</p>

<p>You can set a default value for the input by including a value inside the {{htmlattrxref("value", "input")}} attribute, like so:</p>

<pre class="brush: html notranslate">&lt;label for="week"&gt;What week would you like to start?&lt;/label&gt;
&lt;input id="week" type="week" name="week" value="2017-W01"&gt;</pre>

<p>{{EmbedLiveSample('Value', 600, 60)}}</p>

<p>One thing to note is that the displayed format may differ from the actual <code>value</code>, which is always formatted <code>yyyy-Www</code>. When the above value is submitted to the server, for example, browsers may display it as <code>Week 01, 2017</code>, but the submitted value will always look like <code>week=2017-W01</code>.</p>

<p>You can also get and set the value in JavaScript using the input element's {{domxref("HTMLInputElement.value", "value")}} property, for example:</p>

<pre class="brush: js notranslate">var weekControl = document.querySelector('input[type="week"]');
weekControl.value = '2017-W45';</pre>

<h2 id="Additional_attributes">Additional attributes</h2>

<p>In addition to the attributes common to {{HTMLElement("input")}} elements, week inputs offer the following attributes:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>{{anch("max")}}</code></td>
   <td>The latest year and week to accept as valid input</td>
  </tr>
  <tr>
   <td><code>{{anch("min")}}</code></td>
   <td>The earliest year and week to accept as valid input</td>
  </tr>
  <tr>
   <td><code>{{anch("readonly")}}</code></td>
   <td>A Boolean which, if present, indicates that the user cannot edit the field's contents</td>
  </tr>
  <tr>
   <td><code>{{anch("step")}}</code></td>
   <td>The stepping interval (the distance between allowed values) to use for both user interface and constraint validation</td>
  </tr>
 </tbody>
</table>

<h3 id="htmlattrdefmax">{{htmlattrdef("max")}}</h3>

<p>The latest (time-wise) year and week number, in the string format discussed in the {{anch("Value")}} section above, to accept. If the {{htmlattrxref("value", "input")}} entered into the element exceeds this, the element fails <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">constraint validation</a>. If the value of the <code>max</code> attribute isn't a valid week string, then the element has no maximum value.</p>

<p>This value must be greater than or equal to the year and week specified by the <code>min</code> attribute.</p>

<h3 id="htmlattrdefmin">{{htmlattrdef("min")}}</h3>

<p>The earliest year and week to accept. If the {{htmlattrxref("value", "input")}} of the element is less than this, the element fails <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">constraint validation</a>. If a value is specified for <code>min</code> that isn't a valid week string, the input has no minimum value.</p>

<p>This value must be less than or equal to the value of the <code>max</code> attribute.</p>

<p>{{page("/en-US/docs/Web/HTML/Element/input/text", "readonly", 0, 1, 2)}}</p>

<h3 id="htmlattrdefstep">{{htmlattrdef("step")}}</h3>

<p>{{page("/en-US/docs/Web/HTML/Element/input/number", "step-include")}}</p>

<p>For <code>week</code> inputs, the value of <code>step</code> is given in weeks, with a scaling factor of 604,800,000 (since the underlying numeric value is in milliseconds). The default value of <code>step</code> is 1, indicating 1week. The default stepping base is -259,200,000, which is the beginning of the first week of 1970 (<code>"1970-W01"</code>).</p>

<p><em>At this time, it's unclear what a value of <code>"any"</code> means for <code>step</code> when used with <code>week</code> inputs. This will be updated as soon as that information is determined.</em></p>

<h2 id="Using_week_inputs">Using week inputs</h2>

<p>Week inputs sound convenient at first glance, since they provide an easy UI for choosing weeks, and they normalize the data format sent to the server, regardless of the user's browser or locale. However, there are issues with <code>&lt;input type="week"&gt;</code> because browser support is not guaranteed across all browsers.</p>

<p>We'll look at basic and more complex uses of <code>&lt;input type="week"&gt;</code>, then offer advice on mitigating the browser support issue later on (see {{anch("Handling browser support")}}).</p>

<h3 id="Basic_uses_of_week">Basic uses of week</h3>

<p>The simplest use of <code>&lt;input type="week"&gt;</code> involves a basic <code>&lt;input&gt;</code> and {{htmlelement("label")}} element combination, as seen below:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="week"&gt;What week would you like to start?&lt;/label&gt;
  &lt;input id="week" type="week" name="week"&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Basic_uses_of_week', 600, 40)}}</p>

<h3 id="Controlling_input_size">Controlling input size</h3>

<p><code>&lt;input type="week"&gt;</code> doesn't support form sizing attributes such as {{htmlattrxref("size", "input")}}. You'll have to resort to <a href="/en-US/docs/Web/CSS">CSS</a> for sizing needs.</p>

<h3 id="Using_the_step_attribute">Using the step attribute</h3>

<p>You should be able to use the {{htmlattrxref("step", "input")}} attribute to vary the number of weeks jumped whenever they are incremented or decremented, however it doesn't seem to have any effect on supporting browsers.</p>

<h2 id="Validation">Validation</h2>

<p>By default, <code>&lt;input type="week"&gt;</code> does not apply any validation to entered values. The UI implementations generally don't let you specify anything that isn't a valid week/year, which is helpful, but it's still possible to submit with the field empty, and you might want to restrict the range of choosable weeks.</p>

<h3 id="Setting_maximum_and_minimum_weeks">Setting maximum and minimum weeks</h3>

<p>You can use the {{htmlattrxref("min", "input")}} and {{htmlattrxref("max", "input")}} attributes to restrict the valid weeks that can be chosen by the user. In the following example we are setting a minimum value of <code>Week 01, 2017</code> and a maximum value of <code>Week 52, 2017</code>:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="week"&gt;What week would you like to start?&lt;/label&gt;
  &lt;input id="week" type="week" name="week"
         min="2017-W01" max="2017-W52"&gt;
  &lt;span class="validity"&gt;&lt;/span&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Setting_maximum_and_minimum_weeks', 600, 40)}}</p>

<p>Here's the CSS used in the above example. Here we make use of the {{cssxref(":valid")}} and {{cssxref(":invalid")}} CSS properties to style the input based on whether or not the current value is valid. We had to put the icons on a {{htmlelement("span")}} next to the input, not on the input itself, because in Chrome the generated content is placed inside the form control, and can't be styled or shown effectively.</p>

<pre class="brush: css notranslate">div {
  margin-bottom: 10px;
  position: relative;
}

input[type="number"] {
  width: 100px;
}

input + span {
  padding-right: 30px;
}

input:invalid+span:after {
  position: absolute;
  content: '✖';
  padding-left: 5px;
}

input:valid+span:after {
  position: absolute;
  content: '✓';
  padding-left: 5px;
}</pre>

<p>The result here is that only weeks between W01 and W52 in 2017 will be seen as valid and be selectable in supporting browsers.</p>

<h3 id="Making_week_values_required">Making week values required</h3>

<p>In addition you can use the {{htmlattrxref("required", "input")}} attribute to make filling in the week mandatory. As a result, supporting browsers will display an error if you try to submit an empty week field.</p>

<p>Let's look at an example; here we've set minimum and maximum weeks, and also made the field required:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div&gt;
    &lt;label for="week"&gt;What week would you like to start?&lt;/label&gt;
    &lt;input id="week" type="week" name="week"
         min="2017-W01" max="2017-W52" required&gt;
    &lt;span class="validity"&gt;&lt;/span&gt;
  &lt;/div&gt;
  &lt;div&gt;
      &lt;input type="submit" value="Submit form"&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<p>If you try to submit the form with no value, the browser displays an error. Try playing with the example now:</p>

<p>{{EmbedLiveSample('Making_week_values_required', 600, 120)}}</p>

<p>Here's'a screenshot for those of you who aren't using a supporting browser:</p>

<p><img alt="" src="week-validation-chrome.png" style="display: block; height: 85px; margin: 0px auto; width: 473px;"></p>

<div class="warning">
<p><strong>Important</strong>: HTML form validation is <em>not</em> a substitute for scripts that ensure that the entered data is in the proper format. It's far too easy for someone to make adjustments to the HTML that allow them to bypass the validation, or to remove it entirely. It's also possible for someone to bypass your HTML entirely and submit the data directly to your server. If your server-side code fails to validate the data it receives, disaster could strike when improperly-formatted data is submitted (or data which is too large, of the wrong type, and so forth).</p>
</div>

<h2 id="Handling_browser_support">Handling browser support</h2>

<p>As mentioned above, the major problem with using week inputs right now is browser support: Safari and Firefox don't support it on desktop, and old versions of IE don't support it.</p>

<p>Mobile platforms such as Android and iOS make really good use of such input types, providing specialist UI controls that make it really easy to select values in a touchscreen environment. For example, the <code>week</code> picker on Chrome for Android looks like this:</p>

<p><img alt="" src="week-chrome-android.png" style="display: block; margin: 0 auto;"></p>

<p>Non-supporting browsers gracefully degrade to a text input, but this creates problems both in terms of consistency of user interface (the presented control will be different), and data handling.</p>

<p>The second problem is the more serious. As mentioned earlier, with a <code>week</code> input the actual value is always normalized to the format <code>yyyy-Www</code>. When the browser falls back to a generic text input, there's nothing to guide the user toward correctly formatting the input (and it's certainly not intuitive). There are multiple ways in which people could write week values; for example:</p>

<ul>
 <li><code>Week 1 2017</code></li>
 <li><code>Jan 2-8 2017</code></li>
 <li><code>2017-W01</code></li>
 <li>etc.</li>
</ul>

<p>The best way to deal with week/years in forms in a cross-browser way at the moment is to get the user to enter the week number and year in separate controls ({{htmlelement("select")}} elements being popular; see below for an example), or use JavaScript libraries such as <a href="https://jqueryui.com/datepicker/">jQuery date picker</a>.</p>

<h2 id="Examples">Examples</h2>

<p>In this example we create two sets of UI elements for choosing weeks: a native picker created using <code>&lt;input type="week"&gt;</code>, and a set of two {{htmlelement("select")}} elements for choosing weeks/years in older browsers that don't support the <code>week</code> input type.</p>

<p>{{EmbedLiveSample('Examples', 600, 140)}}</p>

<p>The HTML looks like so:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div class="nativeWeekPicker"&gt;
    &lt;label for="week"&gt;What week would you like to start?&lt;/label&gt;
    &lt;input id="week" type="week" name="week"
           min="2017-W01" max="2018-W52" required&gt;
    &lt;span class="validity"&gt;&lt;/span&gt;
  &lt;/div&gt;
  &lt;p class="fallbackLabel"&gt;What week would you like to start?&lt;/p&gt;
  &lt;div class="fallbackWeekPicker"&gt;
    &lt;div&gt;
      &lt;span&gt;
        &lt;label for="week"&gt;Week:&lt;/label&gt;
        &lt;select id="fallbackWeek" name="week"&gt;
        &lt;/select&gt;
      &lt;/span&gt;
      &lt;span&gt;
        &lt;label for="year"&gt;Year:&lt;/label&gt;
        &lt;select id="year" name="year"&gt;
          &lt;option value="2017" selected&gt;2017&lt;/option&gt;
          &lt;option value="2018"&gt;2018&lt;/option&gt;
        &lt;/select&gt;
      &lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<p>The week values are dynamically generated by the JavaScript code below.</p>

<div class="hidden">
<pre class="brush: css notranslate">div {
  margin-bottom: 10px;
  position: relative;
}

input[type="number"] {
  width: 100px;
}

input + span {
  padding-right: 30px;
}

input:invalid+span:after {
  position: absolute;
  content: '✖';
  padding-left: 5px;
}

input:valid+span:after {
  position: absolute;
  content: '✓';
  padding-left: 5px;
}</pre>
</div>

<p>The other part of the code that may be of interest is the feature detection code. To detect whether the browser supports <code>&lt;input type="week"&gt;</code>, we create a new {{htmlelement("input")}} element, try setting its <code>type</code> to <code>week</code>, then immediately check what its <code>type</code> is set to. Non-supporting browsers will return <code>text</code>, because the <code>week</code> type falls back to type <code>text</code>. If <code>&lt;input type="week"&gt;</code> is not supported, we hide the native picker and show the fallback picker UI ({{htmlelement("select")}}s) instead.</p>

<pre class="brush: js notranslate">// define variables
var nativePicker = document.querySelector('.nativeWeekPicker');
var fallbackPicker = document.querySelector('.fallbackWeekPicker');
var fallbackLabel = document.querySelector('.fallbackLabel');

var yearSelect = document.querySelector('#year');
var weekSelect = document.querySelector('#fallbackWeek');

// hide fallback initially
fallbackPicker.style.display = 'none';
fallbackLabel.style.display = 'none';

// test whether a new date input falls back to a text input or not
var test = document.createElement('input');

try {
  test.type = 'week';
} catch (e) {
  console.log(e.description);
}

// if it does, run the code inside the if() {} block
if(test.type === 'text') {
  // hide the native picker and show the fallback
  nativePicker.style.display = 'none';
  fallbackPicker.style.display = 'block';
  fallbackLabel.style.display = 'block';

  // populate the weeks dynamically
  populateWeeks();
}

function populateWeeks() {
  // Populate the week select with 52 weeks
  for(var i = 1; i &lt;= 52; i++) {
    var option = document.createElement('option');
    option.textContent = (i &lt; 10) ? ("0" + i) : i;
    weekSelect.appendChild(option);
  }
}</pre>

<div class="note">
<p><strong>Note</strong>: Remember that some years have 53 weeks in them (see <a href="https://en.wikipedia.org/wiki/ISO_week_date#Weeks_per_year">Weeks per year</a>)! You'll need to take this into consideration when developing production apps.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comments</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#week-state-(type=week)', '&lt;input type="week"&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.input.input-week")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The generic {{HTMLElement("input")}} element and the interface used to manipulate it, {{domxref("HTMLInputElement")}}</li>
 <li><a href="/en-US/docs/Web/HTML/Date_and_time_formats">Date and time formats used in HTML</a></li>
 <li><code><a href="/en-US/docs/Web/HTML/Element/input/datetime-local">&lt;input type="datetime-local"&gt;</a></code>, <code><a href="/en-US/docs/Web/HTML/Element/input/date">&lt;input type="date"&gt;</a></code>, <code><a href="/en-US/docs/Web/HTML/Element/input/time">&lt;input type="time"&gt;</a></code>, and <code><a href="/en-US/docs/Web/HTML/Element/input/month">&lt;input type="month"&gt;</a></code></li>
 <li><a href="/en-US/docs/Learn/Forms/Property_compatibility_table_for_form_controls">Compatibility of CSS properties</a></li>
</ul>
